

model<-function(iteraction,times,flocks,simtable){




#Organizing the output directory

wd <- getwd()

data.labels <- paste("data",1:iteraction, ".txt", sep="")


layout.matrix <- matrix(c(1, 2, 3, 4,0,0), byrow=T,nrow = 3, ncol = 2)

layout(mat = layout.matrix,
       heights = c(2, 2,0.5), # Heights of the 3 rows
       widths = c(2, 2)) # Widths of the two columns



for(j in 1:simtable){ # looping Scenarios
set.seed(13) 
# All inputs are stored in this file

  source(paste(wd,"/Data/inputs.R",sep=""))

   
  wd.dados <- paste(wd,"/output","/output_scenario",j,sep="")
  dir.create(wd.dados,showWarnings = F)
  
  nome1<-c("Baseline","Long_OC","Short_Fa", "Short_OC", "Fade_ch=0.5", "Beta_ch=5","Heavy=0.001", "Heavy=0.5", "Cross=0.015","Storage=4days" ,"High Leakage","High_slaugh_contaminaiton","No_farmer-exposure","No_food_consum", "No_far&No_food", "Rate=(0.9,0.5)")
  
  par(mar=c(5,5,4,3))
  plot(1:times,seq(0,1,length.out = (times)),type="n", 
       ylab="Prevalence", xlab="Time (Weeks)",xlim=c(1,times),cex=1.2, cex.main=2, cex.lab=2, cex.axis=2,main=paste(nome1[j]))
  
  
  
  for(iter in 1:iteraction){ #Stochasticity at time t
    tempo_inicial1 = proc.time()
    cat("\n\n iteraction: ", iter, "\n")
  
    
    
    rdu<-function(n,k) sample(0:k,n,replace=T)
    set.seed(13)
    H[1]<-prev1
    Fa[1]<-prev2
    time_flock[[1]]<-rdu(flocks,6)
    amu[[1]]<-rbinom(flocks,1,heavy_prop[j])
    
    
    r1[1]<-  (H[1]*(1-H[1]))*col_proc
    r2[1]<-  (Fa[1])*(1-H[1])*expo_fa[j]*col_proc
    r3[1]<-(1 - (1 + ((dose_chi[1] + dose_veg[1])/alfa))^-gama)*non_veg*prob_consu[j]*prev_chi[1]
    r4[1]<-(1 - (1 + ((dose_veg[1])/alfa))^-gama)*non_veg*prob_consu[j]*prev_veg[1]
    r5[1]<- (1-exp(-1/fade_h[j])) # decolonization probability in one week  
    
    p1[1]<-1-((1-r1[1])*(1-r2[1])*(1-r3[1])*(1-r4[1]))
    p2[1]<-r5[1]
    
    r6[1]<-(1-Fa[1])*(H[1])*col_proc2
    r7[1]<-(1-Fa[1])*(C[1])*rate1[j]
    r8[1]<-(1-exp(-1/fade_fa[j]))
    
    p3[1]<-1-((1-r6[1])*(1-r7[1])*(1-r3[1])*(1-r4[1]))
    p4[1]<- r8[1]    
    
    
    r9[[1]]<-  (1-exp(-beta_ch[j]*time_flock[[1]]))*prev3
    r10[[1]]<-  (Fa[1])*(1-prev3)*rate2[j]
    r11[[1]]<- (1-exp(-(1/fade_ch[j])))
    p5[[1]]<-  (r9[[1]]+r10[[1]])-(r9[[1]]*r10[[1]])
    p6[[1]]<-  r11[[1]]
    
    flock[[1]]<- (1-prev3)*p5[[1]]+prev3*(1-p6[[1]])
    C[1]<-mean(flock[[1]][time_flock[[1]]>0])
    media[1]<-mean(flock[[1]][time_flock[[1]]>5])
    
    
    Nenv1[1]<-(  media[1]*aext1*10^(conc1*afec1+log(10)*sig_conc1/2) + 
                   afec1*pfec1[j]*wfec1[j]*(media[1])*10^(conc1+log(10)*sig_conc1/2) )/((benv1[j]+cenv1)-(benv1[j]*cenv1))
    
    Next1[1]<-(1-aext1)*(1-cext1)*media[1]*10^(conc1*afec1+log(10)*sig_conc1/2 )+
      (benv1[j]*(Nenv1[1]))+
      ((1-afec1)*pfec1[j]*wfec1[j]*(media[1])*10^(conc1+log(10)*sig_conc1/2))
    
    #2 step in slaughterhouse: DEFEATHERING
    
    Nenv2[1]<-(  aext2*(Next1[1]) + afec2*wfec2[j]*pfec2[j]*(media[1])*10^(conc2+log(10)*sig_conc2/2) )/((benv2[j]+cenv2)-(benv2[j]*cenv2))
    
    Next2[1]<-(1-aext2)*(1-cext2)*(Next1[1])+
      (benv2[j]*(Nenv2[1]))+
      (1-afec2)*wfec2[j]*pfec2[j]*(media[1])*10^(conc2+log(10)*sig_conc2/2)
    
    
    #3 step in slaughterhouse: EVISCERATION
    
    
    Nenv3[1]<-(  aext3*(Next2[1]) + afec3*pfec3[j]*(media[1])*wfec3[j]*10^(conc3+log(10)*sig_conc3/2) )/((benv3[j]+cenv3)-(benv3[j]*cenv3))
    
    Next3[1]<-(1-aext3)*(1-cext3)*(Next2[1])+
      (benv3[j]*(Nenv3[1]))+
      (1-afec3)*wfec3[j]*pfec3[j]*(media[1])*10^(conc3+log(10)*sig_conc3/2)
    
    
    #5 step in slaughterhouse: CHILLING
    
    
    Nenv5[1]<- ( aext5*(Next3[1]) )/((benv5[j]+cenv5)-(benv5[j]*cenv5))
    
    Next5[1]<-(1-aext5)*(1-cext5)*(Next3[1])+
      (benv5[j]*(Nenv5[1]))
    
    
    if (Next5[1]==0){
      
      dose_chi[1]<-0
      dose_veg[1]<-0
      
    }else{
      
      
      a[1]<-log10(Next5[1]/car_me) #log10(cfu/g)
      prev_slaug[1]<-(media[1]+(1-exp(-Next5[1])))-(media[1]*(1-exp(-Next5[1])))
      
      
      #Sub-module Pre-retail reduction#  Evers`s model#
      #################################################
      
      
      raw[1]<-(a[1]) #log10(cfu/g) concentration at the time t after retail phase. Notice no reduction is happenig
      
      
      
      #Sub-module growth at consumer# Evers`s model#
      ########################################################
      
      tgen<-(tgen_min/((Tst-Tmin)/(Topt-Tmin))^2)
      g<-((log(2)/tgen)*tst[j])/log(10)   #Multiplication factor at 18 C and for 10.8 minutes
      
      
      raw_af[1]<-a[1]+g  # log10(cfu/g) concentration in time t after storage at 18 C and for 10.8 minutes
      
      
      
      #Sub-module cross-contamination at consumer# Evers`s model#
      ###########################################################
      
      raw[1]<- (10^raw_af[1])*consu_ch*(1-frac_cross)
      
      raw_cross[1]<-(10^raw_af[1])*consu_ch * (1-cross[j])*(frac_cross)  #CFU on 1 portion
      
      
      veg_cross[1]<-(10^raw_af[1])*consu_ch * (cross[j])*frac_cross      #CFU on 1 portion
      
      
      
      #Sub-module inactivation at consumer# Evers`s model#
      ####################################################
      
      R<-the*10^((Tend-Tref)/z)/Dref
      
      #Reduction factor at 71.5 C and 15 minutes
      
      
      ready[1]<-log10(raw_cross[1]/consu_ch)+ R    #Final concentration log10(cfu/g) 
      
      ready2[1]<-(log10(raw[1]/consu_ch)+ R)  #Final concentration log10(cfu/g)
      
      
      
      #Sub-module exposure cfu#
      ###########################
      dose_chi[1]<-( (10^ready[1])+(10^ready2[1]) )*consu_ch                             #total dose per contaminated serving (cfu)
      
      dose_veg[1]<-(veg_cross[1])                                                        #total dose per contaminated serving (cfu)
      
      prev_chi[1]<-(1-exp(-10^dose_chi[1]))*prev_slaug[1]                                  #prevalence based on concentration
       
      prev_veg[1]<-(1-exp(-dose_veg[1]))*prev_slaug[1]                                     #Prevalence based on concentration
      
    } #end of if steatment
    
    

    
      
    for (t in 2:times){ #Time running in times 
      tempo_inicial2 = proc.time()
      cat("\n\n day: ", t, "\n")
      
      
      ####################################
      #Module Human and animal population#
      ####################################
      
      
      
      #Sub-module-Open community population#
      #####################################
      
      
      #Frac of open community infec by open community + Frac of infec by farmers +Frac. of open community infec by food. 
      
      r1[t]<-  H[t-1]*((1-H[t-1]))*col_proc
      r2[t]<- (Fa[t-1])*(1-H[t-1])*expo_fa[j]*col_proc
      r3[t]<-(1 - (1 + ((dose_chi[t-1])/alfa))^-gama)*non_veg*prob_consu[j]*prev_chi[t-1]
      r4[t]<-(1 - (1 + ((dose_veg[t-1])/alfa))^-gama)*non_veg*prob_consu[j]*prev_veg[t-1]
      r5[t]<- (1-exp(-1/fade_h[j])) # decolonization probability in one week  
      
      p1[t]<-1-((1-r1[t])*(1-r2[t])*(1-r3[t])*(1-r4[t]))
      p2[t]<-r5[t]
      
      
      H[t]<-  (1-H[t-1])*p1[t]+ H[t-1]*(1-p2[t])
      
      
      #Sub-module-farmers population#
      ###############################
       #Frac of farmers infec by open comunity+ Frac of farmers infec by chickens + Frac of farmers infec by food

        r6[t]<-(H[t-1])*(1-Fa[t-1])*col_proc2
        r7[t]<-(1-Fa[t-1])*(C[t-1])*rate1[j]
        r8[t]<-(1-exp(-1/fade_fa[j]))

        p3[t]<-1-((1-r6[t])*(1-r7[t])*(1-r3[t])*(1-r4[t]))
        p4[t]<- r8[t]    
	
      	Fa[t]<-  (1-Fa[t-1])*p3[t]+ Fa[t-1]*(1-p4[t])
      
      #Sub-module-chicken Population#
      ###############################
      
      
      #Frac. of chikens infect by chickens + #Frac. of chickens infect by farmers - Carries status self clearance (times)
      
      	amu[[t]]<-amu[[t-1]]
      	time_flock[[t]]<-ifelse (time_flock[[t-1]]<6,time_flock[[t-1]]+1,0)
      
      	r9[[t]]<-ifelse(time_flock[[t]]==1,(1-exp(-beta_ch[j]*prev3)),(1-exp(-beta_ch[j]*flock[[t-1]])) )
      	r10[[t]]<-ifelse(time_flock[[t]]!=1,(Fa[t-1])*(1-flock[[t-1]])*rate2[j],  (Fa[t-1])*(1-prev3)*rate2[j])
      	r11[[t]]<-ifelse(amu[[t]]!=1,(1-exp(-(1/(fade_ch[j])))), (1-exp(-(1/(fade_ch[j]*heavy)))))
      	
      	p5[[t]]<-1-((1-r9[[t]])*(1-r10[[t]]))
      	p6[[t]]<-ifelse(time_flock[[t]]!=1,r11[[t]], r11[[t]])
      	
      	flock[[t]]<-ifelse(time_flock[[t]]!=1,(1-flock[[t-1]])*p5[[t]]+flock[[t-1]]*(1-p6[[t]]), (1-prev3)*p5[[t]]+prev3*(1-p6[[t]])  )
  
      	C[t]<-mean(flock[[t]][time_flock[[t]]>0])
        media[t]<-mean(flock[[t]][time_flock[[t]]>5])     

      
      ###########################
      #Module food contamination#
      ###########################
      
      #Sub-module slaughterhouse# Nauta`s model#
      #########################################
      
      ##Expected value
      #1 step in slaughterhouse: SCALDING
      
      Nenv1[t]<-(  media[t]*aext1*10^(conc1*afec1+log(10)*sig_conc1/2) + 
                     afec1*pfec1[j]*wfec1[j]*(media[t])*10^(conc1+log(10)*sig_conc1/2) ) /((benv1[j]+cenv1)-(benv1[j]*cenv1))
      
      Next1[t]<-(1-aext1)*(1-cext1)*media[t]*10^(conc1*afec1+log(10)*sig_conc1/2 )+
        (benv1[j]*(Nenv1[t]))+
        ((1-afec1)*pfec1[j]*wfec1[j]*(media[t])*10^(conc1+log(10)*sig_conc1/2))
      
      #2 step in slaughterhouse: DEFEATHERING
      
      Nenv2[t]<-(  aext2*(Next1[t]) + afec2*wfec2[j]*pfec2[j]*(media[t])*10^(conc2+log(10)*sig_conc2/2) )/((benv2[j]+cenv2)-(benv2[j]*cenv2))
      
      Next2[t]<-(1-aext2)*(1-cext2)*(Next1[t])+
        (benv2[j]*(Nenv2[t]))+
        (1-afec2)*wfec2[j]*pfec2[j]*(media[t])*10^(conc2+log(10)*sig_conc2/2)
      
      
      #3 step in slaughterhouse: EVISCERATION
      
      
      Nenv3[t]<-(  aext3*(Next2[t]) + afec3*pfec3[j]*(media[t])*wfec3[j]*10^(conc3+log(10)*sig_conc3/2) )/((benv3[j]+cenv3)-(benv3[j]*cenv3))
      
      Next3[t]<-(1-aext3)*(1-cext3)*(Next2[t])+
        (benv3[j]*(Nenv3[t]))+
        (1-afec3)*wfec3[j]*pfec3[j]*(media[t])*10^(conc3+log(10)*sig_conc3/2)
      
     
      #4 step in slaughterhouse: CHILLING
      
      
      Nenv5[t]<- ( aext5*(Next3[t]) )/((benv5[j]+cenv5)-(benv5[j]*cenv5))
      
      Next5[t]<-(1-aext5)*(1-cext5)*(Next3[t])+
        (benv5[j]*(Nenv5[t]))
      
      
      if (Next5[t]==0){
        
        dose_chi[t]<-0
        dose_veg[t]<-0
        
      }else{
        
        
        a[t]<-log10(Next5[t]/car_me) #log10(cfu/g)
        
        prev_slaug[t]<-((1-exp(-Next5[t]))+media[t])-((1-exp(-Next5[t]))*media[t])
        
        #Sub-module Pre-retail reduction#  Evers`s model#
        #################################################
        
        
        #(a[t]) #log10(cfu/g) concentration at the time t after retail phase. Notice no reduction is happenig
        
        
        
        #Sub-module growth at consumer# Evers`s model#
        ########################################################
        
        tgen<-(tgen_min/((Tst-Tmin)/(Topt-Tmin))^2)
        g<-((log(2)/tgen)*tst[j])/log(10)   #Multiplication factor at 5.99 C and for 3024 minutes
        
        
        raw_af[t]<-a[t]+g  # log10(cfu/g) concentration in time t after storage at 18 C and for 10.8 minutes
        
        
        
        #Sub-module cross-contamination at consumer# Evers`s model#
        ###########################################################
        
        raw[t]<- (10^raw_af[t])*consu_ch*(1-frac_cross)
        
        raw_cross[t]<-(10^raw_af[t])*consu_ch * (1-cross[j]) *(frac_cross)  #CFU on 1 portion
        
        veg_cross[t]<-(10^raw_af[t])*consu_veg * (cross[j])*frac_cross       #CFU on 1 portion
        
        
        #Sub-module inactivation at consumer# Evers`s model#
        ########################################################
        
        R<-the*10^((Tend-Tref)/z)/Dref
        
        #Reduction factor at 71.5 C and 15 minutes
        
        
        ready[t]<-log10(raw_cross[t]/consu_ch)+ R    #Final concentration log10(cfu/g) in 1 serving with salad
        
        ready2[t]<-(log10(raw[t]/consu_ch)+ R)  #Final concentration log10(cfu/g) in 1 serving without salad
        
        
        #Sub-module exposure cfu#
        #########################
        
        dose_chi[t]<-( (10^ready[t])+(10^ready2[t]) )*consu_ch                    #total dose per contaminated serving (cfu)
        
        dose_veg[t]<-(veg_cross[t])                                                 #total dose per contaminated serving (cfu)
        
        prev_chi[t]<-(1-exp(-10^dose_chi[t]))*prev_slaug[t]                         #prevalence based on concentration
        
        prev_veg[t]<-(1-exp(-dose_veg[t]))*prev_slaug[t]                            #Prevalence based on concentration
        
      } #end of if steatment
      
      
      #Setting up outputs#
      ####################
      
      
    } # End of the looping (time t)
    
    
    data<- cbind(H,media,C,Fa)
    
    
    data.local  <- file.path(wd.dados, data.labels[iter])
    
    
    write.table(data, file = data.local, row.names=FALSE, col.names=TRUE, append=FALSE)
    
 
    lines(1:times, C, col = "green")
    lines(1:times, Fa, col = "blue")
    lines(1:times, H, col = "red")
    lines(1:times, media, col = "yellow")
    
    media_H[iter]<-c(H[times])
    
  } # End of the looping (stochasticity on the time t)
  
  media_H2[j]<-mean(media_H)  
  
  
}#End of scenarios

par(xpd=NA)
legend(-165,-0.5, legend=c("Ope. Commu.", "Chicken","Farmer","Slaug_prev"),
       horiz=TRUE,col=c("red","green", "blue","yellow"), lty=1:1, cex=1.2)


saveRDS(media_H2,paste(wd,"/output/cena.rds",sep=""))

cena<-readRDS(paste(wd,"/output/cena.rds",sep=""))

tornado<-function(){
  par(mfrow=c(1,1))
  base<-cena[1]
nome<-c("Long_OC","Short_Fa", "Short_OC", "Fade_ch=0.5", "Beta_ch=5","Heavy=0.001", "Heavy=0.5", "Cross=0.015","Storage=4days" ,"High Leakage","High_slaugh_contaminaiton","No_farmer_exposure","No_food_consum", "No_far&No_food", "Rate=(0.9,0.5)")

dado<-cbind.data.frame(cena[2:simtable],nome)

sorted<-dado[order(abs(log(cena[2:simtable]/base))),]

sorted1<-dado[order(abs(((cena[2:simtable]-base)))),]

saveRDS(sorted,paste(wd,"/output/sorted.rds",sep=""))
saveRDS(sorted1,paste(wd,"/output/sorted1.rds",sep=""))


par(mar=c(5,13,1,2))
barplot(log(sorted$cena/base),  horiz = T,
        names.arg = sorted$nome,col = "darkgray",las=1,xlab="Log difference",
        ann = FALSE,xlim=c(min(log(sorted$cena/base)),4+max(log(sorted$cena/base))))

mtext(side = 1, text = "log difference", line = 3)

#mtext(side = 2, text = "Scenarios", line = 6.5)



par(mar=c(5,13,1,2))
barplot((sorted1$cena-base),  horiz = T,
        names.arg = sorted1$nome,col = "darkgray",las=1,xaxt="n",
        ann = FALSE,xlim=c(min((sorted1$cena-base)),max((sorted1$cena-base))))
axis(side=1, at=seq(-0.002,0.032,0.001), labels = seq(-0.002,0.032,0.001))
mtext(side = 1, text = "Percentage difference", line = 3)



}

tornado()


}#end function

